// C Source File
// Created 12/8/2001; 5:18:56 PM
	#define OPTIMIZE_ROM_CALLS
	
	#define USE_TI89
	#define USE_TI92PLUS
	#define USE_V200
	
#include "tigcclib.h"
#include "Handler.h"
#include "MatrixCode.h"
#include "Data.h"

void EventHandler(EVENT *ev)
{
//////////////////////////////////////////////
//Prepatory Setup for the Event Handler    //
////////////////////////////////////////////

// a special variable: pointer to a function
	EVENT_HANDLER OldHook;
	
	#ifdef OPTIMIZE_ROM_CALLS
		void *__saved_a5__;//a variable to save the register a5 so it can be restored later
		asm("/*START: Support for OPTIMIZE_ROM_CALLS*/");
		asm("move.l %%a5,%0":"=p"(__saved_a5__));
		asm("move.l 0xC8,%a5");
		asm("/*END: Support for OPTIMIZE_ROM_CALLS*/");
	#endif

/////////////////////////////////////////////////////////////////

//////////////////////////////////////////
//Your Event Handler Code Starts Here  //
////////////////////////////////////////
	if(ev->Type==CM_KEYPRESS)
	{
		if(ev->extra.Key.Code==KEY_F5)
		{//this might be over kill, but this is probabbly the best way to disable auto interrupts 1 and 5 for _rowread
			//otherwise, you can mess up the clock on HW2 calculators running AMS 2.08
			INT_HANDLER old_ai5=GetIntVec(AUTO_INT_5);
			SetIntVec(AUTO_INT_5,DUMMY_HANDLER);
			
			OSSetSR(0x100);
			if(_rowread(~1)&(TI89?0x20:0x04))	//shift + F5 activates
			{
				SetIntVec(AUTO_INT_5,old_ai5);
				OSSetSR(0);	//interupts must be on for grayscale
				ev->Type=CM_IDLE;
				InitializeTheMatrix();
			}
			SetIntVec(AUTO_INT_5,old_ai5);
			OSSetSR(0);
		}
	}
	else
	{
		if(OSTimerCurVal(APD_TIMER)<gTimeout)
			InitializeTheMatrix();	//apd timer ran out so activate the screen saver
	}
///////////////////////////////
//End of Your Event Handler //
/////////////////////////////

///////////////////////////////////////
//Call the Old hook if there was one//
/////////////////////////////////////

//get the address of the next TSR in line to be executed NULL if there is none
  OldHook=gpOldHandler;
  
//Call the old hook if there is one to be called  
  if(OldHook)
  {
  	asm("								/*This inline asm takes the place of OldHook(ev);
  												the difference is that a2 will also contain ev
  												as a parameter to support TEOS. Without this code,
  												you would need to use the switch -ffixed a2 when
  												compiling this example.*/
  	move.l %0,%%a2			/*TEOS expects the parameter to be in a2*/
  	move.l %%a2,-(%%sp)	/*other event hooks expect it on the stack*/
  	move.l %1,%%a0			/*Get the address to call*/
  	jsr (%%a0)					/*Call the next event hook*/
  	addq.l #4,%%sp			/*restore the stack*/
  	"::"p"(ev),"g"(OldHook):"a0","a2");
  }//end if(OldHook)

	#ifdef OPTIMIZE_ROM_CALLS
		asm("/*START: Support for OPTIMIZE_ROM_CALLS*/");
		asm("move.l %0, %%a5	/*support for OPTIMIZE_ROM_CALLS*/"::"p"(__saved_a5__));
		asm("/*END: Support for OPTIMIZE_ROM_CALLS*/");
	#endif

}
