	#define TSR_NAME "MatxScrn"

	#define OPTIMIZE_ROM_CALLS
	
	#define USE_TI89
	#define USE_TI92PLUS
	#define USE_V200

//Necessary Header Files
	#include <tigcclib.h>          //Include All Header Files	
	#include "MatrixCode.h"
	#include "Handler.h"					//The EVENT Hook function
	#include "Data.h"	

//This Code needs TIGCC 0.94 beta 19 at the very least to function properly
#if __TIGCC__==0 && __TIGCC_MINOR__< 94 && __TIGCC_BETA__ < 19
	#warning Sample TSR - Old TIGCC Version -- Check tigcc.ticalc.org for updates
#endif
	
///////////////////////
// EV_hook Header		//
/////////////////////
//The Total Length of this header is 22 bytes
//The Offset to jmp Install_TSR:l is 16 bytes
//The Offset to gpOldHandler is 12 bytes
	asm(".ascii \"evHk" TSR_NAME "\"");			//Offset:  0 bytes
	asm(".globl	gpOldHandler");
	asm("gpOldHandler:");
	asm(".long 0");													//Offset: 12 bytes
	asm("__jmp__Event_Hook__:");
	asm("jmp Install_TSR:l");								//Offset: 16 bytes
//Final offset: 22 bytes
#ifndef NO_CALC_DETECT
	asm(".global __calculator");
	asm("__calculator:");
	asm(".word 0");
#endif
///////////////////////////////
// End of EV_hook Header		//
/////////////////////////////

//Install Function -  this function will be executed ONCE, and ONLY ONCE
void Install_TSR(char* pass, unsigned short timeout)
{
		extern char __jmp__Event_Hook__;
		char *ptr=&__jmp__Event_Hook__;
		
	//Set EventHandler as the default entry point from now on
	//instead of Install_TSR (this function)
		*(unsigned long*)&ptr[2]=(unsigned long)EventHandler;

	#ifndef NO_CALC_DETECT
		asm volatile("
		/* Start Of Calculator Detection Code -- From TIGCC Sources */
				move.l 0xC8,%%a0
				/* Calculator Detection */
				moveq #1,%%d0
				move.l %%a0,%%d1
				and.l #0x400000,%%d1
				jbne __calc_in_d0__
				clr.w %%d0
				move.l (%%a0,0x2F*4),%%a1 /* ScrRect */
				cmp.b #200,2(%%a1)
				jbcs __calc_in_d0__
				moveq #3,%%d0
			__calc_in_d0__:
				lea __calculator(%%pc),%%a1
				move.w %%d0,(%%a1)
		/* End Of Calculator Detection Code -- From TIGCC Sources */"
		:
		:
		: "a0", "a1", "d1");
	#endif
		
	//set the password and timeout variables
		memcpy(gPassword,pass,8);
		gTimeout=timeout;
}


